unit Edit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, Dialogs;

type
  TEditDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    DaonsTable: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    EditA: TEdit;
    Label3: TLabel;
    EditB: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    EditX: TEdit;
    Label6: TLabel;
    EditY: TEdit;
    Label7: TLabel;
    EditZ: TEdit;
    Label9: TLabel;
    Label8: TLabel;
    EditV: TEdit;
    Label10: TLabel;
    EditU: TEdit;
    Label11: TLabel;
    EditW: TEdit;
    Submit: TBitBtn;
    Label12: TLabel;
    NumberOfTaon: TLabel;
    Label15: TLabel;
    EditDT: TEdit;
    EditAnn: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    LGlob: TLabel;
    DaoTrue: TCheckBox;
    Label13: TLabel;
    SaveDialog: TSaveDialog;
    Saveas: TButton;
    YesAnn: TCheckBox;
    EditFileName: TEdit;
    Label14: TLabel;
    Label18: TLabel;
    PotentialVe: TLabel;
    PotentialVp: TLabel;
    PotentialVse: TLabel;
    PotentialVsp: TLabel;
    procedure DaonsTableDblClick(Sender: TObject);
    procedure EditAKeyPress(Sender: TObject; var Key: Char);
    procedure EditAnnKeyPress(Sender: TObject; var Key: Char);
    procedure EditBKeyPress(Sender: TObject; var Key: Char);
    procedure EditDTKeyPress(Sender: TObject; var Key: Char);
    procedure EditUKeyPress(Sender: TObject; var Key: Char);
    procedure EditVKeyPress(Sender: TObject; var Key: Char);
    procedure EditWKeyPress(Sender: TObject; var Key: Char);
    procedure EditXKeyPress(Sender: TObject; var Key: Char);
    procedure EditYKeyPress(Sender: TObject; var Key: Char);
    procedure EditZKeyPress(Sender: TObject; var Key: Char);
    procedure DaonsTableSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormPaint(Sender: TObject);
    procedure SubmitClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure SaveasClick(Sender: TObject);
    procedure DaonsTableClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditDlg: TEditDlg;

implementation

uses Global;

{$R *.DFM}

var
   VeloCity
                    :boolean;

procedure ShowTable1;
var ii,jj:integer;
begin
with EditDlg do
     with DaonsTable do
     if not VeloCity
     then
     begin
     Cells[0,0]:='Gravons';
     Cells[1,0]:='A';Cells[2,0]:='B';
     Cells[3,0]:='X';Cells[4,0]:='Y';Cells[5,0]:='Z';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(A[ii]);
         2:Cells[jj,ii] := FloatToStr(B[ii]);
         3:Cells[jj,ii] := FloatToStr(Xo[ii]);
         4:Cells[jj,ii] := FloatToStr(Yo[ii]);
         5:Cells[jj,ii] := FloatToStr(Zo[ii]);
        end
        else
            Cells[jj,ii] := '';
     end
     else
     begin
     Cells[0,0]:='Velo';
     Cells[1,0]:='A';Cells[2,0]:='B';
     Cells[3,0]:='V(x)';Cells[4,0]:='U(y)';Cells[5,0]:='W(z)';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(A[ii]);
         2:Cells[jj,ii] := FloatToStr(B[ii]);
         3:Cells[jj,ii] := FloatToStr(Vo[ii]);
         4:Cells[jj,ii] := FloatToStr(Uo[ii]);
         5:Cells[jj,ii] := FloatToStr(Wo[ii]);
        end
        else
            Cells[jj,ii] := '';
     end;
end;

// End special procedures

procedure TEditDlg.DaonsTableDblClick(Sender: TObject);
begin
VeloCity:=not VeloCity; ShowTable1;
end;

procedure TEditDlg.EditAKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditAnnKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditBKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditDTKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditUKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditVKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditWKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditXKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditYKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditZKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.DaonsTableSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
NumberOfTaon.Caption:=IntToStr(DaonsTable.Row);
EditA.Text:=FloatToStr(A[DaonsTable.Row]);
EditB.Text:=FloatToStr(B[DaonsTable.Row]);
EditX.Text:=FloatToStr(Xo[DaonsTable.Row]);
EditY.Text:=FloatToStr(Yo[DaonsTable.Row]);
EditZ.Text:=FloatToStr(Zo[DaonsTable.Row]);
EditV.Text:=FloatToStr(Vo[DaonsTable.Row]);
EditU.Text:=FloatToStr(Uo[DaonsTable.Row]);
EditW.Text:=FloatToStr(Wo[DaonsTable.Row]);
if Dao[DaonsTable.Row]
   then DaoTrue.Checked:=true
   else DaoTrue.Checked:=false;
end;

procedure TEditDlg.FormPaint(Sender: TObject);
begin
EditFileName.Text:=ThisName;
NumberOfTaon.Caption:=IntToStr(DaonsTable.Row);
EditA.Text:=FloatToStr(A[DaonsTable.Row]);
EditB.Text:=FloatToStr(B[DaonsTable.Row]);
EditX.Text:=FloatToStr(Xo[DaonsTable.Row]);
EditY.Text:=FloatToStr(Yo[DaonsTable.Row]);
EditZ.Text:=FloatToStr(Zo[DaonsTable.Row]);
EditV.Text:=FloatToStr(Vo[DaonsTable.Row]);
EditU.Text:=FloatToStr(Uo[DaonsTable.Row]);
EditW.Text:=FloatToStr(Wo[DaonsTable.Row]);
if Dao[DaonsTable.Row]
   then DaoTrue.Checked:=true
   else DaoTrue.Checked:=false;
EditDT.Text:=FloatToStr(dt);
EditAnn.Text:=FloatToStr(Ann);
if YAnn
   then YesAnn.Checked:=true
   else YesAnn.Checked:=false;
ShowTable1;
end;

procedure TEditDlg.SubmitClick(Sender: TObject);
var n:integer;
begin
n:=StrToInt(NumberOfTaon.Caption);
A[n]:=StrToFloat(EditA.Text);
B[n]:=StrToFloat(EditB.Text);
Xo[n]:=StrToFloat(EditX.Text);
Yo[n]:=StrToFloat(EditY.Text);
Zo[n]:=StrToFloat(EditZ.Text);
Vo[n]:=StrToFloat(EditV.Text);
Uo[n]:=StrToFloat(EditU.Text);
Wo[n]:=StrToFloat(EditW.Text);
if DaoTrue.Checked
   then Dao[n]:=true
   else Dao[n]:=false;
ShowTable1;
end;

procedure TEditDlg.OKBtnClick(Sender: TObject);
var n:integer;
begin
if SaveDialog.Execute then
begin
// SaveFile
dt:=StrToFloat(EditDT.Text);
Ann:=StrToFloat(EditAnn.Text);
if YesAnn.Checked
   then YAnn:=true else YAnn:=false;
SaveDataOfTaons;
AssignFile(FTaons,SaveDialog.FileName);
Rewrite(FTaons);
Write(FTaons, Taons);
CloseFile(FTaons);
// end SaveFile
ThisName:=SaveDialog.FileName;
StartFile:=ThisName;
{$I-}
Rewrite(FStartFile);
{$I+}
Write(FStartFile,StartFile);
CloseFile(FStartFile);
Ann:=StrToFloat(EditAnn.Text);
if YesAnn.Checked
   then YAnn:=true else YAnn:=false;
dt:=StrToFloat(EditDT.Text);
for n:=1 to MaxTaons do
    if Dao[n] then
       begin
            x[n]:=Xo[n];Xn[n]:=Xo[n];
            y[n]:=Yo[n];Yn[n]:=Yo[n];
            z[n]:=Zo[n];Zn[n]:=Zo[n];
            Vn[n]:=Vo[n];
            Un[n]:=Uo[n];
            Wn[n]:=Wo[n];
       end;
end;//SaveDialog
end;

procedure TEditDlg.SaveasClick(Sender: TObject);
begin
if SaveDialog.Execute then
   begin
   EditFileName.Text:=SaveDialog.FileName;
   dt:=StrToFloat(EditDT.Text);
   Ann:=StrToFloat(EditAnn.Text);
   if YesAnn.Checked then YAnn:=true;
   SaveDataOfTaons;
   AssignFile(FTaons,SaveDialog.FileName);
   Rewrite(FTaons);
   Write(FTaons, Taons);
   CloseFile(FTaons);
   end;
end;

procedure TEditDlg.DaonsTableClick(Sender: TObject);
begin
NumberOfTaon.Caption:=IntToStr(DaonsTable.Row);
EditA.Text:=FloatToStr(A[DaonsTable.Row]);
EditB.Text:=FloatToStr(B[DaonsTable.Row]);
EditX.Text:=FloatToStr(Xo[DaonsTable.Row]);
EditY.Text:=FloatToStr(Yo[DaonsTable.Row]);
EditZ.Text:=FloatToStr(Zo[DaonsTable.Row]);
EditV.Text:=FloatToStr(Vo[DaonsTable.Row]);
EditU.Text:=FloatToStr(Uo[DaonsTable.Row]);
EditW.Text:=FloatToStr(Wo[DaonsTable.Row]);
if Dao[DaonsTable.Row]
   then DaoTrue.Checked:=true
   else DaoTrue.Checked:=false;
ShowTable1;

end;

end.
